<template>
    <div>
        <div class="container-fluid">
            <div class="m-t-20 container">
                <div class="row">
                    <div class="row" id="MainStat">
                        <div class="col-md-12 row">
                            <div v-if="(statData.globalStat.smile.happy + statData.globalStat.smile.sad)> 0">
                                <div class="col-md-12 row">
                                    <div class="col-md-6 p-10 white-box" style="height: 220px; width:50%">
                                        <div class="col-md-6">
                                            <div class="complete-chart" id="graph1"
                                                 :data-percent="(((statData.globalStat.smile.happy * 100) / (statData.globalStat.smile.happy + statData.globalStat.smile.sad))).toFixed(2)"
                                                 data-size="160" data-line="10"
                                                 data-rotate="0"
                                                 data-text="😄"
                                                 data-color="#e74a25" data-text-color="#e74a25">
                                            </div>
                                        </div>
                                        <div class="col-md-6">
                                            <h2>{{(((statData.globalStat.smile.happy * 100) /
                                                (statData.globalStat.smile.happy +
                                                statData.globalStat.smile.sad))).toFixed(2)}}
                                                %</h2>
                                        </div>
                                    </div>
                                    <div class="col-md-6 row p-10 white-box" style="height: 220px; width:50%">
                                        <div class="col-md-6">
                                            <div class="complete-chart" id="graph2"
                                                 :data-percent="(((statData.globalStat.smile.sad * 100) / (statData.globalStat.smile.happy + statData.globalStat.smile.sad))).toFixed(2)"
                                                 data-size="160" data-line="10"
                                                 data-rotate="0"
                                                 data-text="😞"
                                                 data-color="#e74a25" data-text-color="#e74a25">
                                            </div>
                                        </div>
                                        <div class="col-md-6">
                                            <h2>{{(((statData.globalStat.smile.sad * 100) /
                                                (statData.globalStat.smile.happy +
                                                statData.globalStat.smile.sad))).toFixed(2)}}
                                                %</h2>
                                        </div>
                                    </div>
                                </div>
                            </div>
                            <div v-if="(statData.globalStat.trueFalse.yes + statData.globalStat.trueFalse.no) > 0">
                                <div class="col-md-12 row">
                                    <div class="col-md-6 p-10  white-box" style="height: 220px; width:50%">
                                        <div class="col-md-6">
                                            <div class="complete-chart" id="graph1smileyes"
                                                 :data-percent="(((statData.globalStat.trueFalse.yes * 100) / (statData.globalStat.trueFalse.yes + statData.globalStat.trueFalse.no))).toFixed(2)"
                                                 data-size="160" data-line="10"
                                                 data-rotate="0"
                                                 data-text="✔"
                                                 data-color="#e74a25" data-text-color="#e74a25">
                                            </div>
                                        </div>
                                        <div class="col-md-6">
                                            <h2>{{(((statData.globalStat.trueFalse.yes * 100) /
                                                (statData.globalStat.trueFalse.yes +
                                                statData.globalStat.trueFalse.no))).toFixed(2)}}
                                                %</h2>
                                        </div>
                                    </div>
                                    <div class="col-md-6 row p-10 white-box" style="height: 220px; width:50%">
                                        <div class="col-md-6">
                                            <div class="complete-chart" id="graphsmileNo"
                                                 :data-percent="(((statData.globalStat.trueFalse.no * 100) / (statData.globalStat.trueFalse.yes + statData.globalStat.trueFalse.no))).toFixed(2)"
                                                 data-size="160" data-line="10"
                                                 data-rotate="0"
                                                 data-text="✘"
                                                 data-color="#e74a25" data-text-color="#e74a25">
                                                <canvas height="160" width="160"></canvas>
                                            </div>
                                        </div>
                                        <div class="col-md-6">
                                            <h2>{{(((statData.globalStat.trueFalse.no * 100) /
                                                (statData.globalStat.trueFalse.yes +
                                                statData.globalStat.trueFalse.no))).toFixed(2)}}
                                                %</h2>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>


                    </div>
                    <div class="row">

                        <div v-if="statData.nbr_reponse > 0">
                            <div v-for="(question,item) in statData.questions_array">
                                <div v-if="question.type_reponse_id === 1">
                                    <div v-if="typeof(question.options[0].stat) !== 'undefined'">
                                        <case1 :quest="question" :k="item" :key="'chart'+question.id"></case1>
                                    </div>
                                </div>
                                <div v-if="question.type_reponse_id === 2">
                                    <case2 :quest="question" :k="item" :key="'donut'+question.id"></case2>
                                </div>
                                <div v-if="question.type_reponse_id === 3">
                                    <case3 :quest="question" :k="item" :key="'donut'+question.id"></case3>
                                </div>
                                <div v-if="question.type_reponse_id === 4">
                                    <case4 :quest="question" :k="item" :key="'donut'+question.id"></case4>
                                </div>
                                <div v-if="question.type_reponse_id === 5">
                                    <case5 :quest="question" :k="item" :key="'donut'+question.id"></case5>
                                </div>
                                <div v-if="question.type_reponse_id === 6">
                                    <case6 :quest="question" :k="item" :key="'donut'+question.id"></case6>
                                </div>
                                <div v-if="question.type_reponse_id === 7">
                                    <case6 :quest="question" :k="item" :key="'donut'+question.id"></case6>
                                </div>
                                <div v-if="question.type_reponse_id === 8">
                                    <case8 :quest="question" :k="item" :key="'donut'+question.id"></case8>
                                </div>
                            </div>
                        </div>


                    </div>
                </div>
            </div>
        </div>
    </div>
</template>

<script>
    import axios from 'axios';
    import case1 from './cas/case1';
    import case2 from './cas/case2';
    import case3 from './cas/case3';
    import case4 from './cas/case4';
    import case5 from './cas/case5';
    import case6 from './cas/case6';

    export default {
        props: ['sondageid', 'stats'],
        name: 'stat',
        data() {
            return {
                id: this.sondageid,
                statData: JSON.parse(this.stats),

            }
        },
        components:{
            case1,
            case2,
            case3,
            case4,
            case5,
            case6,
        },
        methods: {
            createchart(id) {

                let el = document.getElementById(id); // get canvas

                let options = {
                    percent: el.getAttribute('data-percent') || 50,
                    size: el.getAttribute('data-size') || 160,
                    lineWidth: el.getAttribute('data-line') || 5,
                    inText : el.getAttribute('data-text') || 'null',
                    rotate: el.getAttribute('data-rotate') || 0,
                    color: el.getAttribute('data-color') || '#000',
                    textColor: el.getAttribute('data-text-color') || '#000'
                }

                let canvas = document.createElement('canvas');
                let h1 = document.createElement('h1');
                h1.setAttribute('class', 'per-number');
                h1.innerHTML = options.inText ;
                h1.style.color = options.textColor;
                h1.style.width = options.size+'px';
                let hei = parseInt(options.size) - 6 ;
                h1.style.lineHeight = hei+'px';

                if (typeof(G_vmlCanvasManager) !== 'undefined') {
                    G_vmlCanvasManager.initElement(canvas);
                }

                let ctx = canvas.getContext('2d');
                canvas.width = canvas.height = options.size;

                el.appendChild(h1);
                el.appendChild(canvas);

                ctx.translate(options.size / 2, options.size / 2); // change center
                ctx.rotate((-1 / 2 + options.rotate / 180) * Math.PI); // rotate -90 deg

                //imd = ctx.getImageData(0, 0, 240, 240);
                let radius = (options.size - options.lineWidth) / 2;

                let drawCircle = function(color, lineWidth, percent) {
                    if(percent == 0)
                        return false;
                    percent = Math.min(Math.max(0, percent || 1), 1);
                    ctx.beginPath();
                    ctx.arc(0, 0, radius, 0, Math.PI * 2 * percent, false);
                    ctx.strokeStyle = color;
                    ctx.lineCap = 'round'; // butt, round or square
                    ctx.lineWidth = lineWidth
                    ctx.stroke();
                };

                drawCircle('#e5ebec', options.lineWidth, 100 / 100);
                drawCircle(options.color, options.lineWidth, options.percent / 100);
            }
        },
        mounted() {

            let self = this;
            $(".complete-chart").each(function() {
                let id = $(this).attr("id");
                self.createchart(id);
            });
        }
    }
</script>

<style scoped>

</style>